/* write menu settings file */
void writemenufile(FILE *ofp)
{
  int i, j, cont;

  /* Type of analysis */
  if (typ_optn == LIKMAPING_OPTN)
    fprintf(ofp, "b\n");
  
  /* Parameter estimates */
  if (!approxp_optn) 
    fprintf(ofp, "e\n");

  /* Parameter estimation uses */
  if (!(puzzlemode == USERTREE && typ_optn == TREERECON_OPTN)) {
    if (qcalg_optn)
      fprintf(ofp, "x\n");
  } else {
    if (qcalg_optn)
      fprintf(ofp, "x\n");
    else if (!utree_optn)
      fprintf(ofp, "x\nx\n");
  }

  /* Type of sequence input data */
  if (data_optn == AMINOACID)
    fprintf(ofp, "d\nd\n");
  else if (data_optn == NUCLEOTIDE && SH_optn)
    fprintf(ofp, "d\n");
  else if (data_optn == NUCLEOTIDE && nuc_optn)
    fprintf(ofp, "d\n");
  else if (data_optn == BINARY)
    fprintf(ofp, "d\nd\nd\n");

  if (data_optn == NUCLEOTIDE && (Maxseqc % 3) == 0  && !SH_optn) {
    if (codon_optn == 1) fprintf(ofp, "h\n");
    if (codon_optn == 2) fprintf(ofp, "h\nh\n");
    if (codon_optn == 3) fprintf(ofp, "h\nh\nh\n");
    if (codon_optn == 4) fprintf(ofp, "h\nh\nh\nh\n");
    
  }

  if (data_optn == NUCLEOTIDE && SH_optn && 
      Maxseqc % 2 == 0 && Maxseqc % 3 == 0 && !SHcodon)
      fprintf(ofp, "h\n");

  /* Model of substitution */
  if (data_optn == NUCLEOTIDE) { /* nucleotides */
    if (nuc_optn) {
      if(!HKY_optn) fprintf(ofp, "m\n");	
      
      /* Transition/transversion parameter */
      fprintf(ofp, "t\n%f\n", TSparam);
      
      if (TN_optn) {
	/* Y/R transition parameter */
	fprintf(ofp, "r\n%f\n", YRparam);
      }
    }
    if (SH_optn) {
      fprintf(ofp, "t\n%f\n", TSparam);
    }	
  }

  if (data_optn == AMINOACID) { /* amino acids */
    if (Dayhf_optn) fprintf(ofp, "m\n");	
    if (Jtt_optn) fprintf(ofp, "m\nm\n");
    if (mtrev_optn) fprintf(ofp, "m\nm\nm\n");
    if (cprev_optn) fprintf(ofp, "m\nm\nm\nm\n");
    if (blosum62_optn) fprintf(ofp, "m\nm\nm\nm\n");
    if (vtmv_optn) fprintf(ofp, "m\nm\nm\nm\nm\n");
    if (wag_optn) fprintf(ofp, "m\nm\nm\nm\nm\nm\n");
  }

  fprintf(ofp, "f\n");
  for (i = 0; i < gettpmradix(); i++)
    fprintf(ofp, "%f\n", Freqtpm[i]*100);

  if (data_optn == NUCLEOTIDE) fprintf(ofp, "%f\n", tstvratio);

  /* RATE HETEROGENEITY */
  if (rhetmode == GAMMARATE  ) fprintf(ofp, "w\n");
  if (rhetmode == TWORATE    ) fprintf(ofp, "w\nw\n");
  if (rhetmode == MIXEDRATE  ) fprintf(ofp, "w\nw\nw\n");
  
  if (rhetmode == TWORATE || rhetmode == MIXEDRATE)
    fprintf(ofp, "i\n%f\n", fracinv);
  
  if (rhetmode == GAMMARATE || rhetmode == MIXEDRATE) {
    fprintf(ofp, "a\n%f\n", (1.0-Geta)/Geta);
    fprintf(ofp, "c\n%d\n", numcats);
  }

  if (typ_optn == TREERECON_OPTN && 
      puzzlemode == USERTREE) {
    if (!utree_optn)
      fprintf (ofp, "x\n");
  }

  if (qcalg_optn)
    fprintf (ofp, "x\n");
    
  if (compclock)
    fprintf(ofp, "z\n%d\n", locroot+1);

  if (typ_optn == LIKMAPING_OPTN) {
    fprintf(ofp, "n\n%lu\n", Numquartets);
    
    if (numclust > 1) {
      fprintf(ofp, "g\n%d\n", numclust);

      for (i = 0; i < Maxspc; i++) {

	j = 0;
	cont = 1;

	while (j < Maxspc - 1 && cont) {
	  if (clusterA[j] == i) {
	    fprintf (ofp, "a\n");
	    cont = 0;
	  } else if (clusterB [j] == i) {
	    fprintf (ofp, "b\n");
	    cont = 0;
	  } else if (numclust > 2)
	    if (clusterC [j] == i) {
	      fprintf (ofp, "c\n");
	      cont = 0;
	    } else if (numclust == 4)
	      if (clusterD [j] == i) {
		fprintf (ofp, "d\n");
		cont = 0;
	      }

	  j++;
	}

	if (cont)
	  fprintf (ofp, "x\n");
      }
    }
    
  } /* if WRITEREST) || WRITEALL */

  fprintf (ofp, "y\n");

}
