#ifndef PSTEP_H
#define PSTEP_H

#include<stdio.h>
#include<stdlib.h>
#include"util.h"
#include<stdlib.h>

#ifndef ONEEDGE_DEFINED
#define ONEEDGE_DEFINED

  typedef struct oneedge {
          /* pointer to other three edges */
          struct oneedge *up;
          struct oneedge *downleft;
          struct oneedge *downright;
          int numedge;    /* number of edge */
          uli edgeinfo;   /* value of this edge */
          int *edgemap;   /* pointer to the local edgemap */
  } ONEEDGE;

#endif /* ! ONEEDGE_DEFINED */


#ifndef FPRINTF
#  define FPRINTF fprintf
#  define STDOUT     stdout
#  define STDOUTFILE STDOUT,
#endif

#if 0
  int *edgeofleaf;      /* vector with edge number of all leaves */
  int minedge;          /* edge with minimum edgeinfo */
  int nextedge;         /* number of edges in the current tree */
  int nextleaf;         /* next leaf to add to tree */

  ONEEDGE *edge;        /* vector with all the edges of the tree */
  uli *splitcomp;       /* bipartition storage */
  uli *splitfreqs;      /* frequencies of all different splits of all trees */
  uli *splitpatterns;   /* all different splits of all trees */

  int Maxbrnch;         /* 2*Maxspc - 3 */
  int Maxspc;         /* Maxspc */

  ivector trueID;
  int column;
  uli mininfo;          /* value of edgeinfo on minedge */
#endif


/******************************************************************************/
/* functions for representing and building puzzling step trees                */
/******************************************************************************/

/* initialize tree with the following starting configuration

                 2
          0  +------- C(=2)
  A(=0) -----+
             +------- B(=1)
                 1
                                */
void inittree(ONEEDGE **edge, 
              int     **edgeofleaf, 
              int       Maxspc, 
              int       Maxbrnch, 
              int      *nextedge, 
              int      *nextleaf);

/* add next leaf on the specified edge */
void addnextleaf(int      dockedge,
                 ONEEDGE *edge, 
                 int     *edgeofleaf, 
                 int      Maxspc, 
                 int      Maxbrnch, 
                 int     *nextedge, 
                 int     *nextleaf);

/* free memory (to be called after inittree) */
void freetree(ONEEDGE *edge, 
              int     *edgeofleaf, 
              int      Maxspc);

/* writes OTU sitting on edge ed */
void writeOTU(FILE    *outfp, 
              int      ed, 
              ONEEDGE *edge, 
              int     *edgeofleaf, 
              int      nextedge, 
              int      nextleaf,
              int     *column,
              int     *trueID);

/* write tree */
void writetree(FILE   *outfp,
              ONEEDGE *edge, 
              int     *edgeofleaf, 
              int      nextedge, 
              int      nextleaf,
              int     *trueID);

/* clear all edgeinfos */
void resetedgeinfo(ONEEDGE *edge, 
                   int      nextedge);

/* increment all edgeinfo between leaf A and B */
void incrementedgeinfo(int      A, 
                       int      B,
                       ONEEDGE *edge, 
                       int     *edgeofleaf);

/* checks which edge has the lowest edgeinfo
   if there are several edges with the same lowest edgeinfo,
   one of them will be selected randomly */
void minimumedgeinfo(ONEEDGE *edge, 
                     int     *edgeofleaf, 
                     int      nextedge, 
                     int      nextleaf,
                     int     *minedge, 
                     uli     *mininfo, 
                     int     *howmany);

void testit();

#endif /* PSTEP_H */
